Magellan Linux

Diff of /trunk/mage/usr/lib/mage/mage4.functions.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 1549 by niro, Tue Dec 27 10:43:40 2011 UTC revision 2156 by niro, Wed Aug 14 07:25:43 2013 UTC
# Line 66  mchecksum() Line 66  mchecksum()
66   case ${method} in   case ${method} in
67   md5) cmd="md5sum" ;;   md5) cmd="md5sum" ;;
68   sha256) cmd="sha256sum" ;;   sha256) cmd="sha256sum" ;;
69   *) die "mchecksum(): unkown method '${method}'" ;;   *) die "mchecksum(): unknown method '${method}'" ;;
70   esac   esac
71    
72   if [[ -d ${rundir} ]]   if [[ -d ${rundir} ]]
73   then   then
74   pushd ${rundir} &> /dev/null   pushd ${rundir} &> /dev/null
75   ${cmd} -c ${file} &> /dev/null   # be verbose here
76     ${cmd} -c ${file} #&> /dev/null
77   retval="$?"   retval="$?"
78   popd &> /dev/null   popd &> /dev/null
79   else   else
# Line 82  mchecksum() Line 83  mchecksum()
83   return "${retval}"   return "${retval}"
84  }  }
85    
86    mcheckemptydir()
87    {
88     local dir="$1"
89     local retval=1
90    
91     if [[ ! -d ${dir} ]]
92     then
93     echo "mcheckemptydir(): '${dir}' is not a directory!"
94     retval=3
95     else
96     shopt -s nullglob dotglob
97     files=( ${dir}/* )
98     (( ${#files[*]} )) || retval=0
99     shopt -u nullglob dotglob
100     fi
101    
102     return ${retval}
103    }
104    
105    unpack_package()
106    {
107     local magefile="$1"
108     local pkg
109     local pkgtype
110     local tar_opts
111    
112     pkg="$(get_value_from_magefile PKGNAME ${magefile}).${PKGSUFFIX}"
113     pkgtype="$(get_value_from_magefile PKGTYPE ${magefile})"
114    
115     xtitle "[ Unpacking ${pkg} ]"
116    
117     # abort on virtual pkg
118     if [[ ${pkgtype} = virtual ]]
119     then
120     echo -ne " ${COLBLUE}---${COLDEFAULT}"
121     echo " !unpack virtual ${pkg/.${PKGSUFFIX}/} ... "
122     continue
123     fi
124    
125     # abort on sources pkg
126     if [[ ${pkgtype} = sources ]]
127     then
128     echo -ne " ${COLBLUE}---${COLDEFAULT}"
129     echo " !unpack sources ${pkg/.${PKGSUFFIX}/} ... "
130     continue
131     fi
132    
133     # busybox?
134     if need_busybox_support tar
135     then
136     tar_opts="xjf"
137     else
138     tar_opts="xjmf"
139     fi
140    
141     echo -e " ${COLBLUE}***${COLDEFAULT} unpacking ${pkg} ... "
142     tar ${tar_opts} ${PKGDIR}/${pkg} -C ${BUILDDIR} || die "Unpacking package ${pkg}"
143    }
144    
145  unpack_packages()  unpack_packages()
146  {  {
147   local list="$@"   local list="$@"
148   local magefile   local magefile
  local pkg  
  local pkgtype  
149   local count_current   local count_current
150   local count_total   local count_total
151   local tar_opts   local tar_opts
# Line 100  unpack_packages() Line 158  unpack_packages()
158    
159   for magefile in ${list}   for magefile in ${list}
160   do   do
161   pkg="$(get_value_from_magefile PKGNAME ${magefile}).${PKGSUFFIX}"   unpack_package "${magefile}"
  pkgtype="$(get_value_from_magefile PKGTYPE ${magefile})"  
   
162   (( count_current++ ))   (( count_current++ ))
  xtitle "[ (${count_current}/${count_total}) Unpacking ${pkg} ]"  
   
  # abort on virtual pkg  
  if [[ ${pkgtype} = virtual ]]  
  then  
  echo -ne " ${COLBLUE}---${COLDEFAULT}"  
  echo " !unpack virtual (${count_current}/${count_total}): ${pkg/.${PKGSUFFIX}/} ... "  
  continue  
  fi  
   
  # abort on sources pkg  
  if [[ ${pkgtype} = sources ]]  
  then  
  echo -ne " ${COLBLUE}---${COLDEFAULT}"  
  echo " !unpack sources (${count_current}/${count_total}): ${pkg/.${PKGSUFFIX}/} ... "  
  continue  
  fi  
   
  # busybox?  
  if need_busybox_support tar  
  then  
  tar_opts="xjf"  
  else  
  tar_opts="xjmf"  
  fi  
   
  echo -e " ${COLBLUE}***${COLDEFAULT} unpacking (${count_current}/${count_total}): ${pkg} ... "  
  tar ${tar_opts} ${PKGDIR}/${pkg} -C ${BUILDDIR} || die "Unpacking package ${pkg}"  
163   done   done
164    
165   # add a crlf for a better view   # add a crlf for a better view
# Line 151  fix_mtime() Line 179  fix_mtime()
179   mtime=$(stat -c %Y "${reference}")   mtime=$(stat -c %Y "${reference}")
180   touch \   touch \
181   --no-create \   --no-create \
182     --no-dereference \
183   --time=mtime \   --time=mtime \
184   --reference "${reference}" \   --reference="${reference}" \
185   "${pathto}"   "${pathto}"
186    
187   echo "${mtime}"   echo "${mtime}"
# Line 206  install_directories() Line 235  install_directories()
235   while read pathto posix user group   while read pathto posix user group
236   do   do
237   [ -z "${pathto}" ] && continue   [ -z "${pathto}" ] && continue
238   [[ ${VERBOSE} = on ]] && echo -e "\t>>> DIR:  ${MROOT}${pathto}"   mqueryfeature "verbose" && echo -e "\t>>> DIR:  ${MROOT}${pathto}"
239    
240   # monitors /etc/env.d -> env-rebuild   # monitors /etc/env.d -> env-rebuild
241   [[ ${pathto} = /etc/env.d ]] && export MAGE_ENV_REBUILD=true   [[ ${pathto} = /etc/env.d ]] && export MAGE_ENV_REBUILD=true
# Line 282  install_files() Line 311  install_files()
311   case ${retval} in   case ${retval} in
312   # file is not protected - (over)write it   # file is not protected - (over)write it
313   0|3)   0|3)
314   [[ ${VERBOSE} = on ]] && echo -e "\t>>> FILE: ${MROOT}${pathto}"   mqueryfeature "verbose" && echo -e "\t>>> FILE: ${MROOT}${pathto}"
315   install -m "${posix}" -o "${user}" -g "${group}" \   install -m "${posix}" -o "${user}" -g "${group}" \
316   ${BUILDDIR}/${pkgname}/binfiles/"${pathto}" \   ${BUILDDIR}/${pkgname}/binfiles/"${pathto}" \
317   "${MROOT}${pathto}"   "${MROOT}${pathto}"
# Line 300  install_files() Line 329  install_files()
329    
330   # file is protected, write backup file   # file is protected, write backup file
331   2)   2)
332   if [[ ${VERBOSE} = on ]]   if mqueryfeature "verbose"
333   then   then
334   echo -en "${COLRED}"   echo -en "${COLRED}"
335   echo -n "! prot "   echo -n "! prot "
# Line 331  install_files() Line 360  install_files()
360    
361   # file is protected but ignored, delete the update/do nothing   # file is protected but ignored, delete the update/do nothing
362   4)   4)
363   if [[ ${VERBOSE} = on ]]   if mqueryfeature "verbose"
364   then   then
365   echo -en "${COLRED}"   echo -en "${COLRED}"
366   echo -n "! ignr "   echo -n "! ignr "
# Line 390  install_symlinks() Line 419  install_symlinks()
419   while read pathto posix link mtime   while read pathto posix link mtime
420   do   do
421   [ -z "${pathto}" ] && continue   [ -z "${pathto}" ] && continue
422   [[ ${VERBOSE} = on ]] && echo -e "\t>>> LINK: ${MROOT}${pathto}"   mqueryfeature "verbose" && echo -e "\t>>> LINK: ${MROOT}${pathto}"
423    
424   ln -snf "${link}" "${MROOT}${pathto}"   ln -snf "${link}" "${MROOT}${pathto}"
425    
426  # # fix mtime and db   # fix mtime and db
427  # fix_descriptor ${pkgname}/.symlinks \   fix_descriptor ${pkgname}/.symlinks \
428  # "${pathto}" \   "${pathto}" \
429  # "${posix}" \   "${posix}" \
430  # "${link}" \   "${link}" \
431  # "$(fix_mtime "${BUILDDIR}/${pkgname}"/.mtime \   "$(fix_mtime "${BUILDDIR}/${pkgname}"/.mtime \
432  # "${MROOT}${pathto}")"   "${MROOT}${pathto}")"
433    
434   done < ${BUILDDIR}/${pkgname}/.symlinks   done < ${BUILDDIR}/${pkgname}/.symlinks
435    
# Line 440  install_blockdevices() Line 469  install_blockdevices()
469   while read pathto posix major minor user group   while read pathto posix major minor user group
470   do   do
471   [ -z "${pathto}" ] && continue   [ -z "${pathto}" ] && continue
472   [[ ${VERBOSE} = on ]] && echo -e "\t>>> PIPE: ${MROOT}${pathto}"   mqueryfeature "verbose" && echo -e "\t>>> PIPE: ${MROOT}${pathto}"
473    
474   mknod -m "${posix}" "${MROOT}${pathto}"   mknod -m "${posix}" "${MROOT}${pathto}"
475   # make it optional atm !!   # make it optional atm !!
# Line 484  install_characterdevices() Line 513  install_characterdevices()
513   while read pathto posix major minor user group   while read pathto posix major minor user group
514   do   do
515   [ -z "${pathto}" ] && continue   [ -z "${pathto}" ] && continue
516   [[ ${VERBOSE} = on ]] && echo -e "\t>>> CHAR: ${MROOT}${pathto}"   mqueryfeature "verbose" && echo -e "\t>>> CHAR: ${MROOT}${pathto}"
517    
518   mknod -m ${posix} "${MROOT}${pathto}" b "${major}" "${minor}"   mknod -m ${posix} "${MROOT}${pathto}" b "${major}" "${minor}"
519    
# Line 528  install_fifos() Line 557  install_fifos()
557   while read pathto posix user group   while read pathto posix user group
558   do   do
559   [ -z "${pathto}" ] && continue   [ -z "${pathto}" ] && continue
560   [[ ${VERBOSE} = on ]] && echo -e "\t>>> FIFO: ${MROOT}${pathto}"   mqueryfeature "verbose" && echo -e "\t>>> FIFO: ${MROOT}${pathto}"
561    
562   mkfifo -m "${posix}" "${MROOT}${pathto}"   mkfifo -m "${posix}" "${MROOT}${pathto}"
563   chown "${user}:${group}" "${MROOT}${pathto}"   chown "${user}:${group}" "${MROOT}${pathto}"
# Line 787  compare_mtime() Line 816  compare_mtime()
816    
817   mtime="$(stat -c %Y ${MROOT}${INSTALLDB}/${pfull}/.mtime)"   mtime="$(stat -c %Y ${MROOT}${INSTALLDB}/${pfull}/.mtime)"
818    
819   # if $pathto is a symlink than compare linked binary   # no extra handlink for symlinks anymore as fix_mtime
820   if [ -L "${MROOT}${pathto}" ]   # uses --no-dereference, compare directly
821   then   x=$(stat -c %Y "${MROOT}${pathto}")
  # readlink -f resolves full path of linked file  
  x="$(readlink -f "${MROOT}${pathto}")"  
   
  # abort if target does not exists  
  # we keep safe here, theoretically the link can removed  
  [ ! -e "${x}" ] && return 1  
   
  x=$(stat -c %Y "${x}")  
  else  
  x=$(stat -c %Y "${MROOT}${pathto}")  
  fi  
822    
823   [[ ${mtime} = ${x} ]] && return 0   [[ ${mtime} = ${x} ]] && return 0
824    
# Line 862  remove_symlinks() Line 880  remove_symlinks()
880   [ -z "${pathto}" ] && continue   [ -z "${pathto}" ] && continue
881   if [ ! -L "${MROOT}${pathto}" ]   if [ ! -L "${MROOT}${pathto}" ]
882   then   then
883   [[ ${VERBOSE} = on ]] && \   mqueryfeature "verbose" && \
884   echo -e "${COLRED}! exist${COLDEFAULT} === LINK: ${MROOT}${pathto}"   echo -e "${COLRED}! exist${COLDEFAULT} === LINK: ${MROOT}${pathto}"
885   continue   continue
886   fi   fi
# Line 874  remove_symlinks() Line 892  remove_symlinks()
892   # 1=keep me   #   # 1=keep me   #
893   case ${retval} in   case ${retval} in
894   0)   0)
895   [[ ${VERBOSE} = on ]] && echo -e "\t<<< LINK: ${MROOT}${pathto}"   mqueryfeature "verbose" && echo -e "\t<<< LINK: ${MROOT}${pathto}"
896   rm "${MROOT}${pathto}"   rm "${MROOT}${pathto}"
897   ;;   ;;
898    
899   1)   1)
900   [[ ${VERBOSE} = on ]] && \   mqueryfeature "verbose" && \
901   echo -e "${COLRED}! mtime${COLDEFAULT} === LINK: ${MROOT}${pathto}"   echo -e "${COLRED}! mtime${COLDEFAULT} === LINK: ${MROOT}${pathto}"
902   ;;   ;;
903   esac   esac
# Line 946  remove_files() Line 964  remove_files()
964    
965   if [ ! -e "${MROOT}${pathto}" ]   if [ ! -e "${MROOT}${pathto}" ]
966   then   then
967   [[ ${VERBOSE} = on ]] && \   mqueryfeature "verbose" && \
968   echo -e "${COLRED}! exist${COLDEFAULT} === FILE: ${MROOT}${pathto}"   echo -e "${COLRED}! exist${COLDEFAULT} === FILE: ${MROOT}${pathto}"
969   continue   continue
970   fi   fi
# Line 972  remove_files() Line 990  remove_files()
990   case ${retval} in   case ${retval} in
991   # file is not protected - delete it   # file is not protected - delete it
992   0|3)   0|3)
993   [[ ${VERBOSE} = on ]] && echo -e "\t<<< FILE: ${MROOT}${pathto}"   mqueryfeature "verbose" && echo -e "\t<<< FILE: ${MROOT}${pathto}"
994   rm "${MROOT}${pathto}"   rm "${MROOT}${pathto}"
995   ;;   ;;
996    
997   # file is protected, do not delete   # file is protected, do not delete
998   2)   2)
999   if [[ ${VERBOSE} = on ]]   if mqueryfeature "verbose"
1000   then   then
1001   echo -en "${COLRED}"   echo -en "${COLRED}"
1002   echo -n "! prot "   echo -n "! prot "
# Line 989  remove_files() Line 1007  remove_files()
1007    
1008   # file is protected but ignored, delete the update/do nothing   # file is protected but ignored, delete the update/do nothing
1009   4)   4)
1010   if [[ ${VERBOSE} = on ]]   if mqueryfeature "verbose"
1011   then   then
1012   echo -en "${COLRED}"   echo -en "${COLRED}"
1013   echo -n "! ignr "   echo -n "! ignr "
# Line 1001  remove_files() Line 1019  remove_files()
1019   esac   esac
1020   ;;   ;;
1021   1)   1)
1022   [[ ${VERBOSE} = on ]] && \   mqueryfeature "verbose" && \
1023   echo -e "${COLRED}! mtime${COLDEFAULT} === FILE: ${MROOT}${pathto}"   echo -e "${COLRED}! mtime${COLDEFAULT} === FILE: ${MROOT}${pathto}"
1024   ;;   ;;
1025   esac   esac
# Line 1063  remove_blockdevices() Line 1081  remove_blockdevices()
1081   do   do
1082   [ -z "${pathto}" ] && continue   [ -z "${pathto}" ] && continue
1083    
1084   [[ ${VERBOSE} = on ]] && echo -e "\t<<< PIPE: ${MROOT}${pathto}"   mqueryfeature "verbose" && echo -e "\t<<< PIPE: ${MROOT}${pathto}"
1085   rm "${MROOT}${pathto}"   rm "${MROOT}${pathto}"
1086   done < ${MROOT}${INSTALLDB}/${pfull}/.pipes   done < ${MROOT}${INSTALLDB}/${pfull}/.pipes
1087    
# Line 1123  remove_characterdevices() Line 1141  remove_characterdevices()
1141   do   do
1142   [ -z "${pathto}" ] && continue   [ -z "${pathto}" ] && continue
1143    
1144   [[ ${VERBOSE} = on ]] && echo -e "\t<<< CHAR: ${MROOT}${pathto}"   mqueryfeature "verbose" && echo -e "\t<<< CHAR: ${MROOT}${pathto}"
1145   rm "${MROOT}${pathto}"   rm "${MROOT}${pathto}"
1146   done < ${MROOT}${INSTALLDB}/${pfull}/.char   done < ${MROOT}${INSTALLDB}/${pfull}/.char
1147    
# Line 1185  remove_fifos() Line 1203  remove_fifos()
1203   do   do
1204   [ -z "${pathto}" ] && continue   [ -z "${pathto}" ] && continue
1205    
1206   [[ ${VERBOSE} = on ]] && echo -e "\t<<< FIFO: ${MROOT}${pathto}"   mqueryfeature "verbose" && echo -e "\t<<< FIFO: ${MROOT}${pathto}"
1207   rm "${MROOT}${pathto}"   rm "${MROOT}${pathto}"
1208   done < ${MROOT}${INSTALLDB}/${pfull}/.fifo   done < ${MROOT}${INSTALLDB}/${pfull}/.fifo
1209    
# Line 1246  remove_directories() Line 1264  remove_directories()
1264    
1265   if [ ! -d "${MROOT}${pathto}" ]   if [ ! -d "${MROOT}${pathto}" ]
1266   then   then
1267   [[ ${VERBOSE} = on ]] && \   mqueryfeature "verbose" && \
1268   echo -e "${COLRED}! exist${COLDEFAULT} === DIR:  ${MROOT}${pathto}"   echo -e "${COLRED}! exist${COLDEFAULT} === DIR:  ${MROOT}${pathto}"
1269   continue   continue
1270   fi   fi
# Line 1254  remove_directories() Line 1272  remove_directories()
1272   # exclude .keep directories   # exclude .keep directories
1273   if [ -f "${MROOT}${pathto}/.keep" ]   if [ -f "${MROOT}${pathto}/.keep" ]
1274   then   then
1275   [[ ${VERBOSE} = on ]] && \   mqueryfeature "verbose" && \
1276   echo -e "${COLRED}! .keep${COLDEFAULT} === DIR:  ${MROOT}${pathto}"   echo -e "${COLRED}! .keep${COLDEFAULT} === DIR:  ${MROOT}${pathto}"
1277   continue   continue
1278   fi   fi
# Line 1267  remove_directories() Line 1285  remove_directories()
1285    
1286   if rmdir "${MROOT}${pathto}" &> /dev/null   if rmdir "${MROOT}${pathto}" &> /dev/null
1287   then   then
1288   [[ ${VERBOSE} = on ]] && echo -e "\t<<< DIR:  ${MROOT}${pathto}"   mqueryfeature "verbose" && echo -e "\t<<< DIR:  ${MROOT}${pathto}"
1289   else   else
1290   [[ ${VERBOSE} = on ]] && \   mqueryfeature "verbose" && \
1291   echo -e "${COLRED}! empty${COLDEFAULT} === DIR:  ${MROOT}${pathto}"   echo -e "${COLRED}! empty${COLDEFAULT} === DIR:  ${MROOT}${pathto}"
1292   fi   fi
1293   done   done
# Line 1401  mdownload() Line 1419  mdownload()
1419   real_uris="$(convertmirrors ${uri})"   real_uris="$(convertmirrors ${uri})"
1420    
1421   # verbose or not   # verbose or not
1422   [[ ${VERBOSE} = off ]] && wget_opts="--quiet"   mqueryfeature "!verbose" && wget_opts+=" --quiet"
1423    
1424   # filter wget options if busybox was found   # filter wget options if busybox was found
1425   wget_opts="$(busybox_filter_wget_options ${WGET_FETCH_OPTIONS})"   wget_opts+=" $(busybox_filter_wget_options ${WGET_FETCH_OPTIONS})"
1426    
1427   # create outputdir   # create outputdir
1428   [[ ! -d ${outputdir} ]] && install -d "${outputdir}"   [[ ! -d ${outputdir} ]] && install -d "${outputdir}"
# Line 1488  fetch_packages() Line 1506  fetch_packages()
1506   echo -ne " ${COLBLUE}***${COLDEFAULT}"   echo -ne " ${COLBLUE}***${COLDEFAULT}"
1507   echo -e " fetching (${count_current}/${count_total}): ${pkg} ... "   echo -e " fetching (${count_current}/${count_total}): ${pkg} ... "
1508   mdownload --uri "package://${pkg}" --dir "${PKGDIR}" || die "Could not download ${pkg}"   mdownload --uri "package://${pkg}" --dir "${PKGDIR}" || die "Could not download ${pkg}"
   
1509   if [ ! -f ${PKGDIR}/${pkg} ]   if [ ! -f ${PKGDIR}/${pkg} ]
1510   then   then
1511   die "Package '${pkg}' after download not found in '${PKGDIR}'"   die "Package '${pkg}' after download not found in '${PKGDIR}'"
# Line 1546  syncmage_tarball() Line 1563  syncmage_tarball()
1563    
1564   for mirr in ${MIRRORS}   for mirr in ${MIRRORS}
1565   do   do
1566   # path without distribution   # path without distribution
1567   mymirr="${mirr%/*}"   # (only for stable|testing|unstable and not DISTROTAG)
1568     case ${mirr##*/} in
1569     stable|testing|unstable) mymirr="${mirr%/*}";;
1570     *) mymirr="${mirr}";;
1571     esac
1572    
1573   echo -ne "${COLBLUE} --- ${COLDEFAULT}"   echo -ne "${COLBLUE} --- ${COLDEFAULT}"
1574   echo "fetching latest md5 from ${mymirr} ..."   echo "fetching latest md5 from ${mymirr} ..."
1575   [[ ${VERBOSE} = off ]] && opt="--quiet"   mqueryfeature "!verbose" && opt="--quiet"
1576   wget \   wget \
1577   ${wget_opts} \   ${wget_opts} \
1578   --directory-prefix=${temp} \   --directory-prefix=${temp} \
# Line 1580  syncmage_tarball() Line 1601  syncmage_tarball()
1601   else   else
1602   echo -ne "${COLBLUE} --- ${COLDEFAULT}"   echo -ne "${COLBLUE} --- ${COLDEFAULT}"
1603   echo -n "checking md5sum... "   echo -n "checking md5sum... "
1604   ( cd ${temp}; md5sum -c ${latest_md5} ) || die "md5 for ${latest_tarball} failed"   mchecksum --rundir "${temp}" --file "${latest_md5}" --method md5 || die "md5 for ${latest_tarball} failed"
1605   fi   fi
1606    
1607   if [[ -d ${MAGEDIR} ]]   if [[ -d ${MAGEDIR} ]]
1608   then   then
1609   echo -ne "${COLBLUE} --- ${COLDEFAULT}"   echo -ne "${COLBLUE} --- ${COLDEFAULT}"
1610   echo "cleaning old mage-tree ${MAGEDIR}..."   echo "cleaning old mage-tree ${MAGEDIR}..."
1611   rm -rf ${MAGEDIR}   # honor mountpoints and empty dirs
1612     if mountpoint -q ${MAGEDIR}
1613     then
1614     if ! mcheckemptydir ${MAGEDIR}
1615     then
1616     find ${MAGEDIR} -mindepth 1 -maxdepth 1 | xargs --no-run-if-empty rm -r
1617     fi
1618     else
1619     rm -rf ${MAGEDIR}
1620     fi
1621   fi   fi
1622    
1623   if need_busybox_support tar   if need_busybox_support tar
# Line 1646  xtitleclean() Line 1676  xtitleclean()
1676  }  }
1677    
1678    
1679  # cuts full pathnames or versionized names down to basename  # unused?
1680  choppkgname()  #
1681  {  # # cuts full pathnames or versionized names down to basename
1682   #we want this only if full name was used  # choppkgname()
1683   if [ -n "$(echo ${MAGENAME}|fgrep .mage)" ]  # {
1684   then  # #we want this only if full name was used
1685   #cuts ARCH and PBUILD  # if [ -n "$(echo ${MAGENAME}|fgrep .mage)" ]
1686   #ARCH comes from ${MAGERC}  # then
1687   MAGENAME=$(echo ${MAGENAME} |sed -e "s:-${ARCH}-r*.::g")  # #cuts ARCH and PBUILD
1688    # #ARCH comes from ${MAGERC}
1689    # MAGENAME=$(echo ${MAGENAME} |sed -e "s:-${ARCH}$(print_distrotag)-r*.::g")
1690    #
1691    # #cuts version number
1692    # MAGENAME=$(basename ${MAGENAME%-*} .mage)
1693    # fi
1694    # }
1695    
  #cuts version number  
  MAGENAME=$(basename ${MAGENAME%-*} .mage)  
  fi  
 }  
1696    
1697  # get_categorie $PNAME, returns CATEGORIE  # get_categorie $PNAME, returns CATEGORIE
1698  # $1=pname  # $1=pname
# Line 1738  get_highest_magefile() Line 1771  get_highest_magefile()
1771   then   then
1772   HIGHEST_MAGEFILE=${magefile}   HIGHEST_MAGEFILE=${magefile}
1773   #for debug only   #for debug only
1774   [[ ${MAGEDEBUG} = on ]] && echo "HIGHEST_MAGEFILE=${HIGHEST_MAGEFILE}"   mqueryfeature "debug" && echo "HIGHEST_MAGEFILE=${HIGHEST_MAGEFILE}"
1775   fi   fi
1776   done   done
1777    
# Line 1845  count_protected_files() Line 1878  count_protected_files()
1878   local filename="${file##*/}"   local filename="${file##*/}"
1879   local count   local count
1880   local output   local output
1881     local oldprotected
1882   local i   local i
1883     local x
1884    
1885     # hack; do not honor a global set IFS like '§'
1886     local IFS
1887    
1888   declare -i count=0   count=0
1889    
1890   # check if there are already protected files   # check if there are already protected files
1891   for oldpretected in $(find ${dirname} -iname "._cfg????_${filename}" |   for oldprotected in $(find ${dirname} -iname "._cfg????_${filename}" |
1892   sed -e "s:\(^.*/\)\(._cfg*_\)\(/.*$\):\1\2\3\%\2\%\3:" |   sed -e "s:\(^.*/\)\(._cfg*_\)\(/.*$\):\1\2\3\%\2\%\3:" |
1893   sort -t'%' -k3 -k2 | cut -f1 -d'%')   sort -t'%' -k3 -k2 | cut -f1 -d'%')
1894   do   do
1895   count=$(echo ${oldpretected} | cut -d_ -f2 | sed -e "s:cfg::")   count="$(echo ${oldprotected} | sed 's:.*\/._cfg\(.*\)_.*:\1:')"
1896   done   done
1897   (( count ++ ))  
1898     # convert 0001 -> 1; 0120 -> 120 etc
1899     # use bash internal base functions to this task
1900     x="$((10#${count}))"
1901     for (( i=0; i<x; i++ ))
1902     do
1903     if [[ ${count:${i}:1} != 0 ]]
1904     then
1905     count="${count:${i}}"
1906     break
1907     fi
1908     done
1909    
1910     count="$(( ${count}+1 ))"
1911    
1912   # fill output up with zeros   # fill output up with zeros
1913   for (( i=${#count}; i < 4; i++ )); do output="${output}0"; done   for (( i=${#count}; i < 4; i++ )); do output="${output}0"; done
# Line 2146  minclude() Line 2197  minclude()
2197   then   then
2198   for i in $*   for i in $*
2199   do   do
2200   [[ ${MAGEDEBUG} = on ]] && \   mqueryfeature "debug" && \
2201   echo "--- Including ${MAGEDIR}/include/${i}.minc"   echo "--- Including ${MAGEDIR}/include/${i}.minc"
2202   source ${MAGEDIR}/include/${i}.minc   source ${MAGEDIR}/include/${i}.minc
2203   done   done
2204   [[ ${MAGEDEBUG} = on ]] && echo   mqueryfeature "debug" && echo
2205   fi   fi
2206  }  }
2207    
# Line 2646  mage_install() Line 2697  mage_install()
2697   if [[ ${PKGTYPE} != virtual ]] && \   if [[ ${PKGTYPE} != virtual ]] && \
2698   [[ ${PKGTYPE} != sources ]]   [[ ${PKGTYPE} != sources ]]
2699   then   then
2700     unpack_package "${magefile}"
2701   echo -e " ${COLBLUE}***${COLDEFAULT} merging files into system ... "   echo -e " ${COLBLUE}***${COLDEFAULT} merging files into system ... "
2702   build_doinstall ${PKGNAME}   build_doinstall ${PKGNAME}
2703   fi   fi
# Line 2760  md5sum_packages() Line 2812  md5sum_packages()
2812   then   then
2813   echo -ne "${COLBLUE} *** ${COLDEFAULT}"   echo -ne "${COLBLUE} *** ${COLDEFAULT}"
2814   echo -ne "checking md5sum (${count_current}/${count_total}): "   echo -ne "checking md5sum (${count_current}/${count_total}): "
2815   ( cd ${PKGDIR}; md5sum -c ${md5file}) || die "md5 for ${pkgfile} failed"   mchecksum --rundir "${PKGDIR}" --file "${md5file}" --method md5 || die "md5 for ${pkgfile} failed"
2816   else   else
2817   echo -ne "${COLBLUE} --- ${COLDEFAULT}"   echo -ne "${COLBLUE} --- ${COLDEFAULT}"
2818   echo -e "!! no md5sum file found for ${pkgfile} :("   echo -e "!! no md5sum file found for ${pkgfile} :("
# Line 3000  pkgsearch() Line 3052  pkgsearch()
3052   local state   local state
3053   local descriptiom   local descriptiom
3054   local homepage   local homepage
3055     local license
3056   local i   local i
3057   local all_installed   local all_installed
3058   local ipver   local ipver
# Line 3036  pkgsearch() Line 3089  pkgsearch()
3089   state="$(get_value_from_magefile STATE ${magefile})"   state="$(get_value_from_magefile STATE ${magefile})"
3090   description="$(get_value_from_magefile DESCRIPTION ${magefile})"   description="$(get_value_from_magefile DESCRIPTION ${magefile})"
3091   homepage="$(get_value_from_magefile HOMEPAGE ${magefile})"   homepage="$(get_value_from_magefile HOMEPAGE ${magefile})"
3092     license="$(get_value_from_magefile LICENSE ${magefile})"
3093    
3094   # all installed   # all installed
3095   for i in $(get_uninstall_candidates --pname ${pname} --pcat ${pcat})   for i in $(get_uninstall_candidates --pname ${pname} --pcat ${pcat})
3096   do   do
3097   ipver="$(magename2pver ${i})"   ipver="$(magename2pver ${i})"
3098   ipbuild="$(magename2pbuild ${i})"   ipbuild="$(magename2pbuild ${i})"
3099    
3100   if [[ -z ${all_installed} ]]   if [[ -z ${all_installed} ]]
3101   then   then
3102   all_installed="${ipver}-${ipbuild}"   all_installed="${ipver}-${ipbuild}"
# Line 3051  pkgsearch() Line 3105  pkgsearch()
3105   fi   fi
3106   done   done
3107   [[ -z ${all_installed} ]] && all_installed="none"   [[ -z ${all_installed} ]] && all_installed="none"
3108    
3109   case ${state} in   case ${state} in
3110   stable) state=${COLGREEN}"[s] ";;   stable) state=${COLGREEN}"[s] ";;
3111   testing) state=${COLYELLOW}"[t] ";;   testing) state=${COLYELLOW}"[t] ";;
# Line 3075  pkgsearch() Line 3129  pkgsearch()
3129   "") continue;;   "") continue;;
3130   esac   esac
3131    
3132   deps="${deps} $(basename ${dep%-*})"   if [[ -z ${deps} ]]
3133     then
3134     deps="$(basename ${dep%-*})"
3135     else
3136     deps="${deps} $(basename ${dep%-*})"
3137     fi
3138   done << EOF   done << EOF
3139  ${depsfull}  ${depsfull}
3140  EOF  EOF
# Line 3086  EOF Line 3145  EOF
3145   "") continue;;   "") continue;;
3146   esac   esac
3147    
3148   sdeps="${sdeps} $(basename ${dep%-*})"   if [[ -z ${sdeps} ]]
3149     then
3150     sdeps="$(basename ${dep%-*})"
3151     else
3152     sdeps="${sdeps} $(basename ${dep%-*})"
3153     fi
3154   done << EOF   done << EOF
3155  ${sdepsfull}  ${sdepsfull}
3156  EOF  EOF
# Line 3096  EOF Line 3160  EOF
3160   echo "      Installed versions: ${all_installed}"   echo "      Installed versions: ${all_installed}"
3161   echo "      Description: ${description}"   echo "      Description: ${description}"
3162   echo "      Homepage: ${homepage}"   echo "      Homepage: ${homepage}"
3163   echo "      Depends: ${deps}"   if [[ ! -z ${license} ]]
3164     then
3165     echo "      License:  ${license}"
3166     fi
3167     echo "      Depends:  ${deps}"
3168   echo "      SDepends: ${sdeps}"   echo "      SDepends: ${sdeps}"
3169   echo   echo
3170    
# Line 3136  export_inherits() Line 3204  export_inherits()
3204   eval "${functions}() { ${include}_${functions} ; }"   eval "${functions}() { ${include}_${functions} ; }"
3205    
3206   # debug   # debug
3207   [[ ${MAGEDEBUG} = on ]] && typeset -f "${functions}"   mqueryfeature "debug" && typeset -f "${functions}"
3208    
3209   shift   shift
3210   done   done
# Line 3213  EOF Line 3281  EOF
3281  need_busybox_support()  need_busybox_support()
3282  {  {
3283   local cmd   local cmd
3284     local busybox
3285   cmd="$1"   cmd="$1"
3286    
3287   if [[ -x /bin/busybox ]]   for busybox in {,/usr}/bin/busybox
3288   then   do
3289   if [[ $(readlink $(which ${cmd})) = /bin/busybox ]]   if [[ -x ${busybox} ]]
3290   then   then
3291   # needs busybox support   if [[ $(readlink $(which ${cmd})) = ${busybox} ]]
3292   return 0   then
3293     # needs busybox support
3294     return 0
3295     fi
3296   fi   fi
3297   fi   done
3298    
3299   # no busybox   # no busybox
3300   return 1   return 1
# Line 3274  have_root_privileges() Line 3346  have_root_privileges()
3346    
3347   return ${retval}   return ${retval}
3348  }  }
3349    
3350    known_mage_feature()
3351    {
3352     local feature="$1"
3353     local retval
3354    
3355     case "${feature}" in
3356     autosvc|!autosvc) retval=0 ;;
3357     buildlog|!buildlog) retval=0 ;;
3358     ccache|!ccache) retval=0 ;;
3359     check|!check) retval=0 ;;
3360     compressdoc|!compressdoc) retval=0 ;;
3361     debug|!debug) retval=0 ;;
3362     distcc|!distcc) retval=0 ;;
3363     kernelsrcunpack|!kernelsrcunpack) retval=0 ;;
3364     libtool|!libtool) retval=0 ;;
3365     linuxsymlink|!linuxsymlink) retval=0 ;;
3366     pkgbuild|!pkgbuild) retval=0 ;;
3367     pkgdistrotag|!pkgdistrotag) retval=0 ;;
3368     purge|!purge) retval=0 ;;
3369     qalint|!qalint) retval=0 ;;
3370     regentree|!regentree) retval=0 ;;
3371     resume|!resume) retval=0 ;;
3372     srcpkgbuild|!srcpkgbuild) retval=0 ;;
3373     srcpkgtarball|!srcpkgtarball) retval=0 ;;
3374     static|!static) retval=0 ;;
3375     stepbystep|!stepbystep) retval=0 ;;
3376     strip|!strip) retval=0 ;;
3377     verbose|!verbose) retval=0 ;;
3378     *) retval=1 ;;
3379     esac
3380    
3381     return "${retval}"
3382    }
3383    
3384    load_mage_features()
3385    {
3386     for i in ${MAGE_FEATURES_GLOBAL[*]} ${MAGE_FEATURES[*]}
3387     do
3388     FVERBOSE=off msetfeature ${i}
3389     done
3390    }
3391    
3392    msetfeature()
3393    {
3394     local feature
3395     local count
3396     local i
3397     local found
3398    
3399     for feature in $@
3400     do
3401     found=0
3402     count="${#MAGE_FEATURES_CURRENT[*]}"
3403    
3404     if ! known_mage_feature "${feature}"
3405     then
3406     [[ ${FVERBOSE} = off ]] || echo -e "${COLRED}Unknown feature '${feature}', ignoring it${COLDEFAULT}"
3407     return 3
3408     fi
3409    
3410     for ((i=0; i<count; i++))
3411     do
3412     if [[ ${MAGE_FEATURES_CURRENT[${i}]} = ${feature} ]]
3413     then
3414     [[ ${FVERBOSE} = off ]] || echo -e "${COLBLUE}---${COLGREEN} Feature '${feature}' already enabled${COLDEFAULT}"
3415     MAGE_FEATURES_CURRENT[${i}]="${feature}"
3416     found=1
3417     elif [[ ${MAGE_FEATURES_CURRENT[${i}]} = !${feature} ]]
3418     then
3419     [[ ${FVERBOSE} = off ]] || echo -e "${COLBLUE}---${COLGREEN} Feature '${feature}' currently disabled, enabling it!${COLDEFAULT}"
3420     MAGE_FEATURES_CURRENT[${i}]="${feature}"
3421     found=1
3422     elif [[ ${MAGE_FEATURES_CURRENT[${i}]} = ${feature//!} ]]
3423     then
3424     [[ ${FVERBOSE} = off ]] || echo -e "${COLBLUE}---${COLGREEN} Feature '${feature//!}' currently enabled, disabling it!${COLDEFAULT}"
3425     MAGE_FEATURES_CURRENT[${i}]="${feature}"
3426     found=1
3427     fi
3428     done
3429    
3430     # if the feature was not found after proccessing the whole array
3431     # it was not declared. in this case enable it
3432     if [[ ${found} = 0 ]]
3433     then
3434     [[ ${FVERBOSE} = off ]] || echo -e "${COLBLUE}---${COLGREEN} Feature '${feature}' was not declared, enabling it!${COLDEFAULT}"
3435     MAGE_FEATURES_CURRENT=( ${MAGE_FEATURES_CURRENT[*]} "${feature}" )
3436     fi
3437    
3438     export MAGE_FEATURE_CURRENT
3439     done
3440    }
3441    
3442    mqueryfeature()
3443    {
3444     local feature="$1"
3445     local retval=1
3446     local i
3447    
3448     if known_mage_feature "${feature}"
3449     then
3450     for i in ${MAGE_FEATURES_CURRENT[*]}
3451     do
3452     if [[ ${i} = ${feature} ]]
3453     then
3454     retval=0
3455     break # found break here
3456     fi
3457     done
3458     else
3459     [[ ${FVERBOSE} = off ]] || echo -e "${COLRED}Unknown feature '${feature}', ignoring it${COLDEFAULT}"
3460     retval=3
3461     fi
3462    
3463     return ${retval}
3464    }
3465    
3466    mprintfeatures()
3467    {
3468     echo -e "${COLRED}Global features:${COLDEFAULT} ${MAGE_FEATURES_GLOBAL[*]}"
3469     echo -e "${COLYELLOW}Local features:${COLDEFAULT} ${MAGE_FEATURES[*]}"
3470     echo -e "${COLGREEN}Current features:${COLDEFAULT} ${MAGE_FEATURES_CURRENT[*]}"
3471    }

Legend:
Removed from v.1549  
changed lines
  Added in v.2156